"""
Django settings for core project.

Generated by 'django-admin startproject' using Django 5.0.3.

For more information on this file, see
https://docs.djangoproject.com/en/5.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/5.0/ref/settings/
"""

from decouple import config
import dj_database_url
from pathlib import Path

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

SECURE_PROXY_SSL_HEADER = ("HTTP_X_FORWARDED_PROTO", "https")

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/5.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = config(
    "SECRET_KEY",
    default="django-insecure-0_!x2mb-7086$f_by1w2qqn^5o9$-&syb-tewk@eilib#plrp2",
)

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = config(
    "DEBUG",
    cast=bool,
    default=True,
)

ALLOWED_HOSTS = config(
    "ALLOWED_HOSTS",
    cast=lambda it: list(map(str.strip, it.split(","))),
    default='*',
)


# Application definition

INSTALLED_APPS = [
    "core",
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "whitenoise.runserver_nostatic",
    "django.contrib.staticfiles",
    "social_django",
    "votes.apps.VotesConfig",
    "django_bootstrap5",
    "model_guard.apps.ModelGuardConfig",
    "debug_toolbar",
]

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "whitenoise.middleware.WhiteNoiseMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "debug_toolbar.middleware.DebugToolbarMiddleware",
]

ROOT_URLCONF = "core.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [BASE_DIR / "templates"],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
                "social_django.context_processors.backends",
                "social_django.context_processors.login_redirect",
            ],
        },
    },
]

WSGI_APPLICATION = "core.wsgi.application"


# Database
# https://docs.djangoproject.com/en/5.0/ref/settings/#databases

DATABASES = {
    "default": dj_database_url.parse(config(
        'DATABASE_URL',
        default='sqlite:///' + str(BASE_DIR.absolute() / "db.sqlite3")
    ))
}

ATOMIC_REQUESTS = True

# Password validation
# https://docs.djangoproject.com/en/5.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]

AUTHENTICATION_BACKENDS = (
    "social_core.backends.keycloak.KeycloakOAuth2",
    "django.contrib.auth.backends.ModelBackend",
    "model_guard.backends.ObjectPermissionBackend",
)


# Internationalization
# https://docs.djangoproject.com/en/5.0/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = config(
    "TIME_ZONE",
    default="UTC",
)

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/5.0/howto/static-files/

STATIC_URL = "static/"
STATIC_ROOT = BASE_DIR / "static/"

# Default primary key field type
# https://docs.djangoproject.com/en/5.0/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"
LOGIN_REDIRECT_URL = "/"


INTERNAL_IPS = (
    '127.0.0.1',
)


SOCIAL_AUTH_URL_NAMESPACE = 'oauth2'
SOCIAL_AUTH_JSONFIELD_ENABLED = config('SOCIAL_AUTH_JSONFIELD_ENABLED', cast=bool, default=True)
SOCIAL_AUTH_REQUIRE_POST = config('SOCIAL_AUTH_REQUIRE_POST', cast=bool, default=False)
SOCIAL_AUTH_FORCE_EMAIL_VALIDATION = config('SOCIAL_AUTH_FORCE_EMAIL_VALIDATION', cast=bool, default=True)
SOCIAL_AUTH_KEYCLOAK_PUBLIC_KEY = config('SOCIAL_AUTH_KEYCLOAK_PUBLIC_KEY', default=None)
SOCIAL_AUTH_KEYCLOAK_KEY = config('SOCIAL_AUTH_KEYCLOAK_KEY', default=None)
SOCIAL_AUTH_KEYCLOAK_SECRET = config('SOCIAL_AUTH_KEYCLOAK_SECRET', default=None)
SOCIAL_AUTH_KEYCLOAK_AUTHORIZATION_URL = config('SOCIAL_AUTH_KEYCLOAK_AUTHORIZATION_URL', default=None)
SOCIAL_AUTH_KEYCLOAK_ACCESS_TOKEN_URL = config('SOCIAL_AUTH_KEYCLOAK_ACCESS_TOKEN_URL', default=None)
SOCIAL_AUTH_KEYCLOAK_ID_KEY = config('SOCIAL_AUTH_KEYCLOAK_ID_KEY', default='email')
SOCIAL_AUTH_KEYCLOAK_SCOPE = config(
    'SOCIAL_AUTH_KEYCLOAK_SCOPE',
    cast=lambda it: list(map(str.strip, it.split(' '))),
    default='openid',
)


# https://python-social-auth.readthedocs.io/en/latest/pipeline.html#authentication-pipeline
SOCIAL_AUTH_PIPELINE = (
    # Get the information we can about the user and return it in a simple
    # format to create the user instance later. In some cases the details are
    # already part of the auth response from the provider, but sometimes this
    # could hit a provider API.
    'social_core.pipeline.social_auth.social_details',

    # Get the social uid from whichever service we're authing thru. The uid is
    # the unique identifier of the given user in the provider.
    'social_core.pipeline.social_auth.social_uid',

    # Verifies that the current auth process is valid within the current
    # project, this is where emails and domains whitelists are applied (if
    # defined).
    'social_core.pipeline.social_auth.auth_allowed',

    # Checks if the current social-account is already associated in the site.
    'social_core.pipeline.social_auth.social_user',

    # Make up a username for this person, appends a random string at the end if
    # there's any collision.
    'social_core.pipeline.user.get_username',

    # Send a validation email to the user to verify its email address.
    # Disabled by default.
    #'social_core.pipeline.mail.mail_validation',

    # Associates the current social details with another user account with
    # a similar email address. Disabled by default.
    'social_core.pipeline.social_auth.associate_by_email',

    # Create a user account if we haven't found one yet.
    'social_core.pipeline.user.create_user',

    # Create the record that associates the social account with the user.
    'social_core.pipeline.social_auth.associate_user',

    # Populate the extra_data field in the social record with the values
    # specified by settings (and the default ones like access_token, etc).
    'social_core.pipeline.social_auth.load_extra_data',

    # Update the user record with any changed info from the auth service.
    'social_core.pipeline.user.user_details',
    
    'core.auth_pipeline.parse_authorization_info',
    #'core.auth_pipeline.create_authorization_info_groups',
    'core.auth_pipeline.sync_authorization_info',
)